﻿using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using AddinExpress.MSO;
using Outlook = Microsoft.Office.Interop.Outlook;
using System.Diagnostics;

namespace OutlookRules
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("A59F875C-12D9-4BB6-9F3D-C91337E6AA9D"), ProgId("OutlookRules.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            Application.EnableVisualStyles();
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }

        private ADXRibbonTab adxRibbonTab1;
        private ADXRibbonGroup adxRibbonGroup1;
        private ADXRibbonButton runRuleRibbonButton;
        private ImageList imageList1;
        private ADXRibbonComboBox ruleNamesRibbonComboBox;
        private ADXRibbonCheckBox includeSubFoldersRibbonCheckBox;

        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;

        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(AddinModule));
            this.adxRibbonTab1 = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.adxRibbonGroup1 = new AddinExpress.MSO.ADXRibbonGroup(this.components);
            this.ruleNamesRibbonComboBox = new AddinExpress.MSO.ADXRibbonComboBox(this.components);
            this.includeSubFoldersRibbonCheckBox = new AddinExpress.MSO.ADXRibbonCheckBox(this.components);
            this.runRuleRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.imageList1 = new System.Windows.Forms.ImageList(this.components);
            // 
            // adxRibbonTab1
            // 
            this.adxRibbonTab1.Caption = "Custom Rules";
            this.adxRibbonTab1.Controls.Add(this.adxRibbonGroup1);
            this.adxRibbonTab1.Id = "adxRibbonTab_7d764db33299402f8c9490c0357f36f7";
            this.adxRibbonTab1.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            // 
            // adxRibbonGroup1
            // 
            this.adxRibbonGroup1.Caption = "Rules Runner";
            this.adxRibbonGroup1.Controls.Add(this.ruleNamesRibbonComboBox);
            this.adxRibbonGroup1.Controls.Add(this.includeSubFoldersRibbonCheckBox);
            this.adxRibbonGroup1.Controls.Add(this.runRuleRibbonButton);
            this.adxRibbonGroup1.Id = "adxRibbonGroup_93eb00d36e4c47dc85e7f4198c9fa8e5";
            this.adxRibbonGroup1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonGroup1.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            // 
            // ruleNamesRibbonComboBox
            // 
            this.ruleNamesRibbonComboBox.Caption = "Rule name";
            this.ruleNamesRibbonComboBox.Id = "adxRibbonComboBox_debf1f196ca54a80a63fafdd36b4a1ec";
            this.ruleNamesRibbonComboBox.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.ruleNamesRibbonComboBox.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            // 
            // includeSubFoldersRibbonCheckBox
            // 
            this.includeSubFoldersRibbonCheckBox.Caption = "Include Sub-folders";
            this.includeSubFoldersRibbonCheckBox.Id = "adxRibbonCheckBox_44d387d4288b42edaa859a7b3366c821";
            this.includeSubFoldersRibbonCheckBox.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            // 
            // runRuleRibbonButton
            // 
            this.runRuleRibbonButton.Caption = "Run Rule in current Folder";
            this.runRuleRibbonButton.Id = "adxRibbonButton_ae4370120dcc49f4a0d9e95c23934ef3";
            this.runRuleRibbonButton.Image = 0;
            this.runRuleRibbonButton.ImageList = this.imageList1;
            this.runRuleRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.runRuleRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            this.runRuleRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.runRuleRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.runRuleRibbonButton_OnClick);
            // 
            // imageList1
            // 
            this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
            this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
            this.imageList1.Images.SetKeyName(0, "walk.png");
            // 
            // AddinModule
            // 
            this.AddinName = "OutlookRules";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;
            this.AddinStartupComplete += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinStartupComplete);

        }
        #endregion

        #region Add-in Express automatic code

        // Required by Add-in Express - do not modify
        // the methods within this region

        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }

        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }

        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }

        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public static new AddinModule CurrentInstance
        {
            get
            {
                return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
            }
        }

        public Outlook._Application OutlookApp
        {
            get
            {
                return (HostApplication as Outlook._Application);
            }
        }

        private void AddinModule_AddinStartupComplete(object sender, EventArgs e)
        {
            Outlook.NameSpace session = null;
            Outlook.Store store = null;
            Outlook.Rules rules = null;
            Outlook.MAPIFolder destinationFolder = null;
            Outlook.MAPIFolder rootFolder = null;
            Outlook.Folders rootFolderFolders = null;

            Outlook.Rule rule = null;
            Outlook.RuleConditions ruleConditions = null;
            Outlook.TextRuleCondition subjectTextRuleCondition = null;

            Outlook.RuleActions ruleActions = null;
            Outlook.MoveOrCopyRuleAction moveRuleAction = null;

            string ruleName = string.Empty;

            try
            {
                ruleName = "Move Order Mails Rule";
                session = OutlookApp.Session;
                store = session.DefaultStore;
                rules = store.GetRules();

                if (!RuleExist(ruleName, rules))
                {
                    rootFolder = store.GetRootFolder();
                    destinationFolder = GetFolder(rootFolder.FolderPath + "\\Orders", this.OutlookApp);

                    if (destinationFolder == null)
                    {
                        rootFolderFolders = rootFolder.Folders;
                        destinationFolder = rootFolderFolders.Add("Orders");
                    }

                    rule = rules.Create(ruleName, Outlook.OlRuleType.olRuleReceive);
                    ruleConditions = rule.Conditions;

                    subjectTextRuleCondition = ruleConditions.Subject;
                    subjectTextRuleCondition.Text = new string[] { "Orders", "orders", "Order", "order" };
                    subjectTextRuleCondition.Enabled = true;

                    ruleActions = rule.Actions;
                    moveRuleAction = ruleActions.MoveToFolder;
                    moveRuleAction.Folder = destinationFolder;
                    moveRuleAction.Enabled = true;

                    ruleActions.DesktopAlert.Enabled = true;

                    rules.Save(true);
                }
                LoadRules();
            }
            catch (Exception ex)
            {
                Debug.Write(ex.Message);
            }
            finally
            {
                if (moveRuleAction != null)
                    Marshal.ReleaseComObject(moveRuleAction);
                if (ruleActions != null)
                    Marshal.ReleaseComObject(ruleActions);
                if (subjectTextRuleCondition != null)
                    Marshal.ReleaseComObject(subjectTextRuleCondition);
                if (ruleConditions != null)
                    Marshal.ReleaseComObject(ruleConditions);
                if (rule != null)
                    Marshal.ReleaseComObject(rule);
                if (rootFolderFolders != null)
                    Marshal.ReleaseComObject(rootFolderFolders);
                if (rootFolder != null)
                    Marshal.ReleaseComObject(rootFolder);
                if (destinationFolder != null)
                    Marshal.ReleaseComObject(destinationFolder);
                if (rules != null)
                    Marshal.ReleaseComObject(rules);
                if (store != null)
                    Marshal.ReleaseComObject(store);
                if (session != null)
                    Marshal.ReleaseComObject(session);
            }
        }

        private void runRuleRibbonButton_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            Outlook.Explorer currExplorer = null;
            Outlook.MAPIFolder currFolder = null;
            Outlook.NameSpace session = null;
            Outlook.Store defaultStore = null;

            Outlook.Rules rules = null;
            Outlook.Rule selectedRule = null;

            try
            {
                currExplorer = OutlookApp.ActiveExplorer();
                currFolder = currExplorer.CurrentFolder;
                session = currExplorer.Session;
                defaultStore = session.DefaultStore;
                rules = defaultStore.GetRules();

                selectedRule = rules[ruleNamesRibbonComboBox.Text];

                if (selectedRule != null)
                {
                    selectedRule.Execute(true, currFolder, includeSubFoldersRibbonCheckBox.Pressed, Outlook.OlRuleExecuteOption.olRuleExecuteAllMessages);
                }
            }
            catch (Exception ex)
            {
                Debug.Write(ex.Message);
            }
            finally
            {
                if (selectedRule != null)
                    Marshal.ReleaseComObject(selectedRule);
                if (rules != null)
                    Marshal.ReleaseComObject(rules);
                if (defaultStore != null)
                    Marshal.ReleaseComObject(defaultStore);
                if (session != null)
                    Marshal.ReleaseComObject(session);
                if (currFolder != null)
                    Marshal.ReleaseComObject(currFolder);
                if (currExplorer != null)
                    Marshal.ReleaseComObject(currExplorer);
            }
        }

        private void LoadRules()
        {
            Outlook.NameSpace session = null;
            Outlook.Store store = null;
            Outlook.Rules rules = null;

            try
            {
                session = OutlookApp.Session;
                store = session.DefaultStore;
                rules = store.GetRules();

                for (int i = 1; i <= rules.Count; i++)
                {
                    Outlook.Rule rule = rules[i];
                    ADXRibbonItem item = new ADXRibbonItem();
                    item.Caption = rule.Name;
                    ruleNamesRibbonComboBox.Items.Add(item);
                }
            }
            finally
            {
                if (rules != null)
                    Marshal.ReleaseComObject(rules);
                if (store != null)
                    Marshal.ReleaseComObject(store);
                if (session != null)
                    Marshal.ReleaseComObject(session);
            }
        }

        public static Outlook.Folder GetFolder(string folderPath, Outlook._Application outlookApp)
        {
            Outlook.Folder returnFolder = null;
            Outlook.Folders subFolders = null;
            Outlook.NameSpace session = null;
            Outlook.Folders sessionFolders = null;

            try
            {
                session = outlookApp.Session;
                folderPath = folderPath.TrimStart("\\".ToCharArray());

                String[] folders = folderPath.Split("\\".ToCharArray());
                sessionFolders = session.Folders;
                returnFolder = sessionFolders[folders[0]] as Outlook.Folder;


                if (returnFolder != null)
                {
                    String folderName;
                    for (int i = 1; i < folders.Length; i++)
                    {
                        folderName = folders[i];
                        subFolders = returnFolder.Folders;
                        returnFolder = subFolders[folderName] as Outlook.Folder;
                    }
                }
            }
            catch
            {
                returnFolder = null;
            }
            finally
            {
                if (sessionFolders != null)
                    Marshal.ReleaseComObject(sessionFolders);
                if (session != null)
                    Marshal.ReleaseComObject(session);
                if (subFolders != null)
                    Marshal.ReleaseComObject(subFolders);
            }
            return returnFolder;
        }

        private bool RuleExist(string ruleName, Outlook.Rules rules)
        {
            bool exist = false;

            for (int i = 1; i <= rules.Count; i++)
            {
                Outlook.Rule rule = rules[i];
                if (rule.Name == ruleName)
                {
                    Marshal.ReleaseComObject(rule);
                    exist = true;
                    break;
                }
                Marshal.ReleaseComObject(rule);
            }
            return exist;
        }

    }
}

